#ifndef MGROUP_H
#define MGROUP_H

#include "pre.h"
#include "mbranch.h"
#include "mcgate.h"
#include <malloc.h>
#include <stdio.h>


typedef MCGate* PMCGate;
typedef TransList* PTransList;

class MGroup {
    public:
	MosList *moshead;
	NodeList *nodehead;
	TransList *transhead;
//	WireList *wirehead;
	InoutList *inputhead;
	InoutList *outputhead;

	int num_of_gates;
	int num_of_trans;
	MBranch *p_branch_list;
	MBranch *n_branch_list;
	MosList *pass_transistor_list;
	MosList *left_transistor_list;
	MCGate *cmos_gate_list;
//	MCGate *special_gate_list;
	PMCGate *hash_gate_list;
	PTransList *hash_trans_list;
	
	MGroup(MosList *moshead_, NodeList *nodehead_, InoutList *inputhead_, InoutList *outputhead_);
	~MGroup();

	int return_number(char *name);
	char *get_vdd(MosList *moshead);
	char *get_gnd(MosList *moshead);
	int query_n_branch(char *name);
	int query_p_branch(char *name);
	MBranch *insert_branch(MBranch *head, MBranch *new_branch);
	void undelete_mosfet(MosList *mlist);
	void generate_branch_list();
	void group_branch_list();
	MosList *insert_mos(MosList *head, MosList *mos);
	void exchange_d_s(MosList *mos);
	int query_is_pnnode(char *name);
	int query_is_gnode(char *name);
	void generate_pass_left_list();
	TransList *insert_trans(TransList *head,const char *name, char *input, char *output, char *p_g, char *n_g);
	void undelete_mos_in_pass();
	void generate_trans_list();
	int counter(MBranch *branch);
	void generate_num_for_branch();
	char *generate_add(char *g1, char g2);
	char *generate_add(char g1, char g2);
	char *generate_add(char *g1, char *g2);
	char *generate_mult(char *g1, char g2);
	char *generate_mult(char g1, char g2);
	char *generate_mult(char *g1, char *g2);
	char *generate_parenthes(char *g);
	char *generate_mark(char *g);
	char change_g(MBranch *n_branch, MosList *mos1, MosList *mos2, char turn, int add_or_flag);
	int is_series_node(char *nodename, MBranch *curr_branch);
	GateNameList *insert_gatename(GateNameList *head, char *name);
	RelationList *insert_relation(RelationList *head, int type, GateNameList *gnlist);
	RelationList *query_alone_list(RelationList *rlist);
	
	char parallel_recognition(MBranch *n_branch, char turn);
	char series_recognition(MBranch *n_branch, char turn);
	void n_branch_recognition();
	void p_branch_recognition();
	MCGate *insert_cgate(MCGate *head, MCGate *newgate);
	void gate_recognition();
	void gen_hash_gate_list();
	void gen_hash_trans_list();
	bool query_in_gate_list(char *name, PinList *plist);
	PinList *insert_pin(PinList *head, char *name);
	bool query_in_pinlist(char *name, PinList *plist);
	void gen_inlist_for_gate();
	
	void gen_connection_of_gates();
	void gen_connection_of_trans();
	void count_input_num_of_node();



//	int query_inoutput(char *name);
//	WireList *insert_wire(WireList *head, char *name);
//	int query_wire(char *wire);
//	void generate_wirelist();
//	void delete_wire();
	
};

#endif
