#include "pre.h"
#include "cgate.h"
#include "branch.h"
#include "group.h"
#include "wire.h"
#include <string>
#include <iostream>
#include <malloc.h>
#include <stdio.h>
#include <cstring>
using namespace std;


extern int node_biggest;
extern int num_of_gates;
extern int num_of_trans;
extern PTransList *hash_trans_list;
extern PCGate *hash_gate_list;

extern ResultList *ResultHead;
extern WireList *WireHead;
extern PNodeList *hash_node_list;
extern ResultList *ResultHead;


#define NLAlloc(type,num) (type *)calloc(num,sizeof(type))
#define ionumber 500


Wire::Wire()
{
}

Wire::~Wire()
{
}

int
Wire::return_number(char *name)
{
        char *st = NLAlloc(char, strlen(name));
        strcpy(st, name);
        char *ret=NULL;
        ret = NLAlloc(char, strlen(st));
        int counter = 0;

        bool begin_f=false;
        bool end_f=false;

        int i=0;
        while(st[i]!='\0')
        {
                if(st[i]>=48 && st[i]<=57 && st[i]!='\0')
                {
                        begin_f = true;
                        ret[counter]=st[i];
                        counter+=1;
                }
                if(begin_f && st[i]!='\0' && ( st[i]<48 || st[i]>57 ))
                {
                        end_f = true;
                        break;
                }
                i+=1;
        }
        ret[counter] =  '\0';

        if(begin_f && !end_f)
        {
                return atoi(ret);
        }
        else
        {
                return -1;
        }
}

NodeList *
Wire::get_node(char *nodename)
{
        int rval = return_number(nodename);
        if(rval != -1)
                return hash_node_list[rval];
        else
        {
                for(int i=node_biggest+1; i<(node_biggest+ionumber); i++)
                {
                  if(hash_node_list[i] != NULL)
                  {
                        if(!strcmp(nodename, hash_node_list[i]->nodename))
                                return hash_node_list[i];
                  }
                }
        }
}




WireList *
Wire::insert_wire(WireList *head, char *name)
{
    WireList *current;
    if(head==NULL)
    {
	head=NLAlloc(WireList,1);
	head->wirename=NLAlloc(char, strlen(name));
	strcpy(head->wirename,name);
	head->next = NULL;
    }
    else
    {
	current=NLAlloc(WireList,1);
	current->wirename=NLAlloc(char, strlen(name));
	strcpy(current->wirename,name);
	current->next = head->next;
	head->next = current;
    }
    return head;
}

bool
Wire::query_is_terminal(char *name)
{
	for(InoutList *curr=InputHead; curr!=NULL; curr=curr->next)
	{
		if(!strcmp(name, curr->pinname))
			return true;
	}
	for(InoutList *curr=OutputHead; curr!=NULL; curr=curr->next)
	{
		if(!strcmp(name, curr->pinname))
			return true;
	}
	return false;
}

void
Wire::generate_wirelist()
{
	for(int i=0; i<num_of_gates; i++)
	{
		if(hash_gate_list[i]!=NULL)
		{
			for(PinList *curr=hash_gate_list[i]->inlist; curr!=NULL; curr=curr->next)
			{
				NodeList *hnode = get_node(curr->NodeName);
				if(!hnode->wire && !query_is_terminal(curr->NodeName))
				{
					WireHead = insert_wire(WireHead,curr->NodeName);
					hnode->wire = true;
				}
			}
		}
	}


	for(ResultList *curr=ResultHead; curr!=NULL; curr=curr->next)
	{
		for(EqualNameList *ce=curr->input_list; ce!=NULL; ce=ce->next)
		{
			NodeList *nnode = get_node(ce->circuit_name);
			if(!nnode->wire && !query_is_terminal(ce->circuit_name))
			{
				WireHead = insert_wire(WireHead,ce->circuit_name);
				nnode->wire = true;
			}
		}
		for(EqualNameList *ce=curr->output_list; ce!=NULL; ce=ce->next)
		{
			NodeList *nnnode = get_node(ce->circuit_name);
			if(!nnnode->wire && !query_is_terminal(ce->circuit_name))
			{
				WireHead = insert_wire(WireHead,ce->circuit_name);
				nnnode->wire = true;
			}
		}
	}
}


