#ifndef BRANCH_H
#define BRANCH_H

#include "pre.h"
#include <malloc.h>
#include <stdio.h>

extern MosList *MosHead;
extern NodeList *NodeHead;


class Branch {
     
     friend class Group;

     public:
	char *branchname;
	int success;
	int ready_to_delete;
	int greatthan4;
	char *headername;
	int branch_type;
	char *pn_node;
	MosList *mos_list;
	MosList *bak_mos_list;  // Revised
	int num_of_mos;
	BranchNodeList *node_list;
	NameList *name_list;
	RelationList *relation_list;
	Branch *next;


	Branch(int _branch_type);
	~Branch();

	int return_number(char *name);
	NodeList *get_node(char *nodename);
	char *get_vdd(MosList *moshead);
	char *get_gnd(MosList *moshead);
	int node_exist(char *node);
	int query_moslist(MosList *mos);
	MosList *insert_mos(MosList *head, MosList *mos);
	BranchNodeList *insert_node(BranchNodeList *head, char *node);
	BranchNodeList *find_new_node(BranchNodeList *branchnode_list, int p_n_type);
	bool generate_branch(MosList *mos, int p_n_type);
	NameList *insert_name(NameList *head, char *name, char virtual_name);
	void back_up_mos_list();
};

#endif
