#ifndef GROUP_H
#define GROUP_H

#include "pre.h"
#include "branch.h"
#include "cgate.h"
#include <malloc.h>
#include <stdio.h>
#include <string>
#include <cstring>

extern MosList *MosHead;
extern NodeList *NodeHead;

//extern int num_of_gates;
//extern int num_of_trans;
//extern PCGate *hash_gate_list;
//extern PTransList *hash_trans_list;

typedef CGate* PCGate;
typedef Branch* PBranch;
typedef TransList* PTransList;

class Group {
    public:
//	int num_of_gates;
//	int num_of_trans;
	int num_of_p_branches;
	int num_of_n_branches;
	Branch *p_branch_list;
	Branch *n_branch_list;
	PBranch *hash_p_branch_list;
	PBranch *hash_n_branch_list;
	MosList *pass_transistor_list;
	MosList *left_transistor_list;
	CGate *cmos_gate_list;
//	CGate *special_gate_list;
//	PCGate *hash_gate_list;
//	PTransList *hash_trans_list;
	
	Group();
	~Group();
	int return_number(char *name);
	NodeList *get_node(char *nodename);
	char *get_vdd(MosList *moshead);
	char *get_gnd(MosList *moshead);
	int query_n_branch(char *name);
	int query_p_branch(char *name);
	Branch *insert_branch(Branch *head, Branch *new_branch);
	void undelete_mosfet(MosList *mlist);
	void generate_branch_list();
	void group_branch_list();
	MosList *insert_mos(MosList *head, MosList *mos);
	void exchange_d_s(MosList *mos);
	int query_is_pnnode(char *name);
	int query_is_gnode(char *name);
	void generate_pass_left_list();
	TransList *insert_trans(TransList *head,const char *name, char *input, char *output, char *p_g, char *n_g);
	void undelete_mos_in_pass();
	void generate_trans_list();
	int counter(Branch *branch);
	void generate_num_for_branch();
	char *generate_add(char *g1, char g2);
	char *generate_add(char g1, char g2);
	char *generate_add(char *g1, char *g2);
	char *generate_mult(char *g1, char g2);
	char *generate_mult(char g1, char g2);
	char *generate_mult(char *g1, char *g2);
	char *generate_parenthes(char *g);
	char *generate_mark(char *g);
	char change_g(Branch *n_branch, MosList *mos1, MosList *mos2, char turn, int add_or_flag);
	int is_series_node(char *nodename, Branch *curr_branch);
	GateNameList * insert_gatename(GateNameList *head, char *name);
	RelationList * insert_relation(RelationList *head, int type, GateNameList *gnlist);
	RelationList *query_alone_list(RelationList *rlist);
	char parallel_recognition(Branch *n_branch, char turn);
	char series_recognition(Branch *n_branch, char turn);
	void n_branch_recognition();
	void p_branch_recognition();
	CGate *insert_cgate(CGate *head, CGate *newgate);
	void give_name_to_branch();
	void gen_hash_branch_list();
	void couple_p_n_branch();
	void gate_recognition();
	void gen_hash_gate_list();
	void gen_hash_trans_list();

	bool query_in_gate_list(char *name, PinList *plist);
	PinList *insert_pin(PinList *head, char *name);
	bool query_in_pinlist(char *name, PinList *plist);

	void gen_inlist_for_gate();
	
	void gen_connection_of_gates();
	void gen_connection_of_trans();
	void count_input_num_of_node();
	int count_mos_list(MosList *mlist);
	void gen_num_for_macromodel();


//	int query_inoutput(char *name);
//	WireList *insert_wire(WireList *head, char *name);
//	int query_wire(char *wire);
//	void generate_wirelist();
//	void delete_wire();
	
};

#endif
