#ifndef _MACROMODEL
#define _MACROMODEL

#include "pre.h"
#include "mtellnp.h"
#include "mnode.h"
#include "mbranch.h"
#include "mgroup.h"
#include <stdio.h>
#include <malloc.h>
#include <iostream>
#include <malloc.h>
#include <stdio.h>
using namespace std;


class Macromodel {

    public:


	char *name;
	MacroModelList *macromodel;

	WireList *wire_list;
	ModelList *modelhead;
	InoutList *inputhead;
	InoutList *outputhead;
	MosList *mos_list;
	NodeList *node_list;
	TransList *trans_list;
	GateStack *gate_stack;
	NodeStack *node_stack;

	int num_of_gates;
	int num_of_trans;
	PMCGate *hash_gate_list;
	PTransList *hash_trans_list;
	
	InoutList *insert_inout(InoutList *head, char *name);

	Macromodel(MacroModelList *amacromodel);
	~Macromodel();

	int return_number(char *name);
	void gen_data_structure();
	GateStack *insert_gate(GateStack *head, int type, char *name);
	void initialize_gate_stack();
	NodeStack *insert_node(NodeStack *head, char *name, bool terminal_flag);
	bool query_terminal(char *name);
	void initialize_node_stack();
	bool decide_a_gate(char *name);
	char *return_gate(char *name);
	MCGate *locate_first_gate();
	bool gatestack_search_to_end();
	bool nodestack_search_to_end();
	RGList *insert_return_gate(RGList *head, char *name, int type);
	RGList *return_a_trans_input_list(char *gatename);
	RGList *return_a_trans_output_list(char *gatename);
	RGList *return_a_gate_list(char *gatename);
	bool query_is_terminal(char *name);
	void unique_rglist(RGList *glist);
	void insert_gates_in_gatestack(char *mname, char *cname);
	void insert_node_in_nodestack(char *mname, char *cname);
	bool check_dead_loop();
	char * gate_has_been_found(char *name);
	PinList *insert_pin(PinList *head, char *name);
	PinList *return_found_gate_list(char *gatename);
	bool query_node_in_nodestack(char *name);
	bool query_gate_in_nodestack(char *name);
	bool query_in_inputlist(char *name);
	bool query_in_outputlist(char *name);
	PinList *return_found_gate_list_for_a_pin(char *pinname);
	RelationList * locate_relation_list(char *name, RelationList *rlist);
	RelationList *return_n_relation_list(char *name);
	RelationList *return_p_relation_list(char *name);
	GateNameList *insert_gatename(GateNameList *head, char *name);
	char *return_node_from_nodestack(char *name);
	GateNameList *relation_list_is_valid(char *name, RelationList *rlist);
	void reinitialize_macromodel();
	PinList * return_the_input_gate_list(char *name);
	void reset_search_flag(char *name);
	void deal_with_dead_loop2();
	bool node_not_found_yet(char *name);
	bool gatename_list_not_found_yet(GateNameList *gnlist);
	char *find_circuit_gate_name(char *name);
	void insert_two_gatename_list(GateNameList *mlist, GateNameList *clist);
	GateStack * insert_copy_gate(GateStack *head, GateStack *gs);
	GateStack * copy_gate_stack();
	bool compare_element_of_gate_stack(GateStack *ele, GateStack *new_gs);
	bool compare_two_gatestack(GateStack *old_gs, GateStack *new_gs);
	bool query_gate_has_been_found(char *name);
	void set_trans_search_flag_one();



};

#endif
	
