#include "pre.h"
#include "branch.h"
#include "group.h"
#include "node.h"
#include "tellnp.h"
#include <malloc.h>
#include <stdio.h>
#include <string.h>

#define NLAlloc(type,num) (type *)calloc(num,sizeof(type))

extern int yyerror(char const *);
extern int yywrap();
extern int yyparse();
extern FILE *yyin;

Element *ElementHead;
Action *ActionHead;
Modellist *ModelHead;

MosList *MosHead;
NodeList *NodeHead;


int main(int argc, char *argv[]) 
{
    FILE *fp_out;

    if(argc>2)
    {
	yyin = fopen(argv[1], "r");
	if(yyin == NULL)
	{
	    perror("can not open source file !\n");
	    exit(-1);
	}
	fp_out = fopen(argv[2], "w");
	if(fp_out==NULL) 
	{
	    perror("can not open destination file !\n");
	    exit(-1);
	}
    }
    else
    {
	printf("Useage: parser input output \n");
	exit(0);
    }

    ElementHead = NULL;
    ActionHead = NULL;
    ModelHead = NULL;
    MosHead = NULL;

    yyparse();

/****** Add p or n character of Mosfet netlist *******/
    TellNP *tellnp;
    tellnp = new TellNP();
    tellnp->mos_np_netlist();
/*    
    for(MosList *cur_m=MosHead; cur_m!=NULL; cur_m=cur_m->next)
	printf("%s %d	",cur_m->mosname,cur_m->nptype);
    printf("\n");
*/
/****** Genarate NodeList ***************************/
    Node *mynode;
    mynode = new Node();
    mynode->gen_nodelist();
    mynode->gen_np_char_netlist();
/*    
    for(NodeList *cur_n=NodeHead; cur_n!=NULL; cur_n=cur_n->next)
    {
	printf("%s(%d): ", cur_n->nodename,cur_n->pn_node);
	for(DeviceList *cur_d=cur_n->devicelist; cur_d!=NULL; cur_d=cur_d->next)
	    printf("%s ",cur_d->devicename);
	printf("\n");
    }
*/
/****** Generate 4 moslist *************************/
    Group *mygroup;
    mygroup = new Group();
    mygroup->generate_branch_list();

/*
    printf("N_Branch_list\n");
    Branch *cur_b=mygroup->n_branch_list;
    if(cur_b==NULL)
	printf("empty\n");
    else if(cur_b->next==NULL)
	printf("only one\n");
    else {
    for(; cur_b!=NULL; cur_b=cur_b->next)
    {
	printf("n_branch_list_i:\n");
	printf("n_or_p=%d, success=%d, pn_node=%s\n",cur_b->branch_type,cur_b->success,cur_b->pn_node);
	printf("Moslist: ");
	for(MosList *cur_mo=cur_b->mos_list; cur_mo!=NULL; cur_mo=cur_mo->next)
	    printf("%s  ", cur_mo->mosname);
	printf("\n");
	printf("Nodelist: ");
	if(cur_b->node_list==NULL)
	    printf("No internal node\n");
	else
	{
	for(BranchNodeList *cur_no=cur_b->node_list; cur_no!=NULL; cur_no=cur_no->next)
	    printf("%s  ",cur_no->nodename);
	printf("\n");
	}
    }
    }

    printf("P_Branch_list\n");
    Branch *cur_bb=mygroup->p_branch_list;
    if(cur_bb==NULL)
        printf("empty\n");
    else if(cur_bb->next==NULL)
        printf("only one\n");
    else {
    for(; cur_bb!=NULL; cur_bb=cur_bb->next)
    {
        printf("n_branch_list_i:\n");
        printf("n_or_p=%d, success=%d, pn_node=%s\n",cur_bb->branch_type,cur_bb->success,cur_bb->pn_node);
        printf("Moslist: ");
        for(MosList *cur_mo=cur_bb->mos_list; cur_mo!=NULL; cur_mo=cur_mo->next)
            printf("%s  ", cur_mo->mosname);
        printf("\n");
        printf("Nodelist: ");
        if(cur_bb->node_list==NULL)
            printf("No internal node\n");
        else
        {
        for(BranchNodeList *cur_no=cur_bb->node_list; cur_no!=NULL; cur_no=cur_no->next)
            printf("%s  ",cur_no->nodename);
        printf("\n");
	}
    }
    }
*/
    mygroup->generate_pass_left_list();

    mygroup->group_branch_list();

/*
    printf("N_Branch_list\n");
    Branch *cur_b=mygroup->n_branch_list;
    if(cur_b==NULL)
        printf("empty\n");
    else if(cur_b->next==NULL)
        printf("only one\n");
    else {
    for(; cur_b!=NULL; cur_b=cur_b->next)
    {
        printf("n_branch_list_i:\n");
        printf("n_or_p=%d, success=%d, pn_node=%s\n",cur_b->branch_type,cur_b->success,cur_b->pn_node);
        printf("Moslist: ");
        for(MosList *cur_mo=cur_b->mos_list; cur_mo!=NULL; cur_mo=cur_mo->next)
            printf("%s  ", cur_mo->mosname);
        printf("\n");
        printf("Nodelist: ");
        if(cur_b->node_list==NULL)
            printf("No internal node\n");
        else
        {
        for(BranchNodeList *cur_no=cur_b->node_list; cur_no!=NULL; cur_no=cur_no->next)
            printf("%s  ",cur_no->nodename);
        printf("\n");
        }
    }
    }

    printf("P_Branch_list\n");
    Branch *cur_bb=mygroup->p_branch_list;
    if(cur_bb==NULL)
        printf("empty\n");
    else if(cur_bb->next==NULL)
        printf("only one\n");
    else {
    for(; cur_bb!=NULL; cur_bb=cur_bb->next)
    {
        printf("n_branch_list_i:\n");
        printf("n_or_p=%d, success=%d, pn_node=%s\n",cur_bb->branch_type,cur_bb->success,cur_bb->pn_node);
        printf("Moslist: ");
        for(MosList *cur_mo=cur_bb->mos_list; cur_mo!=NULL; cur_mo=cur_mo->next)
            printf("%s  ", cur_mo->mosname);
        printf("\n");
        printf("Nodelist: ");
        if(cur_bb->node_list==NULL)
            printf("No internal node\n");
        else
        {
        for(BranchNodeList *cur_no=cur_bb->node_list; cur_no!=NULL; cur_no=cur_no->next)
            printf("%s  ",cur_no->nodename);
        printf("\n");
        }
    }
    }
*/
    mygroup->branch_recognition();

/***** Output Result ******************************/
    fprintf(fp_out, "* The following netlist is the static CMOS netlist\n");
    fprintf(fp_out, "\n");

//Output the non-mosfet devices
    fprintf(fp_out, "* Output the non-mosfet devices\n");
    Element *current;
    PinList *curr_pin;
    while(current != NULL)
    {
	fprintf(fp_out, "%s ", current->name);
	
	curr_pin = current->nodelist;
	while(curr_pin != NULL)
	{
	    fprintf(fp_out,"%s ", curr_pin->NodeName);
	    curr_pin = curr_pin->next;
	}

	fprintf(fp_out, "%e ", current->value);

	if(current->Model != NULL)
	    fprintf(fp_out, "%s ", current->Model); 
	    
	fprintf(fp_out, "\n");

	current = current->next;
    }

//Output the recognized and unrecognized CMOS gates
    fprintf(fp_out, "* Output the recognized and unrecognized CMOS gates:\n");
    Branch *my_branch;
    my_branch = mygroup->n_branch_list;
    for( ; my_branch!=NULL; my_branch=my_branch->next) 
    {
	if(my_branch->success)
	{
	    fprintf(fp_out, "* gate(recognized)\n");
	    fprintf(fp_out, "* Input signal is:\n");
	    for(BranchNodeList *cur_node=my_branch->node_list; cur_node!=NULL; cur_node=cur_node->next)
	    {
		for(NodeList *big_node=NodeHead; big_node!=NULL; big_node=big_node->next)
		{
		    if(!strcmp(cur_node->nodename, big_node->nodename))
		    {
			for(DeviceList *cur_device=big_node->devicelist; cur_device!=NULL; cur_device=cur_device->next)
			    fprintf(fp_out, "%s ", cur_device->g);
			break;
		    }
		}
	    }
	    fprintf(fp_out, "\n");

	    fprintf(fp_out, "* Output signal is:\n");
	    fprintf(fp_out, "%s \n", my_branch->pn_node);

	    fprintf(fp_out, "* Logic function is:\n");
	    MosList *tem = my_branch->mos_list;
	    fprintf(fp_out, "!(%s)\n", tem->g);
	}
	else
	{
	    fprintf(fp_out, "* Unrecognized CMOS:\n");
	    for(BranchNodeList *curr=my_branch->node_list; curr!=NULL; curr=curr->next)
	    {
		for(NodeList *big=NodeHead; big!=NULL; big=big->next)
		{
		    if(!strcmp(curr->nodename, big->nodename))
		    {
			for(DeviceList *curr_device=big->devicelist; curr_device!=NULL; curr_device=curr_device->next)
			{
			    for(MosList *curr_mos=MosHead; curr_mos!=NULL; curr_mos=curr_mos->next)
			    {
				if(!strcmp(curr_mos->mosname, curr_device->devicename))
				{
				    fprintf(fp_out,"%s %s %s %s %s %s L=%e W=%e\n",curr_mos->mosname,curr_mos->d,curr_mos->g,curr_mos->s,curr_mos->b,curr_mos->modelname,curr_mos->lvalue,curr_mos->wvalue);
				    break;
				}
			    }
			}
			break;
		    }
		}
	    }
	}
    }

    for(my_branch=mygroup->p_branch_list; my_branch!=NULL; my_branch=my_branch->next)
    {
	if(!my_branch->success)
	{
	    for(BranchNodeList *curr=my_branch->node_list; curr!=NULL; curr=curr->next)
	    {
		for(NodeList *big=NodeHead; big!=NULL; big=big->next)
		{
		    if(!strcmp(curr->nodename, big->nodename))
		    {
			for(DeviceList *curr_device=big->devicelist; curr_device!=NULL; curr_device=curr_device->next)
			{
			    for(MosList *curr_mos=MosHead; curr_mos!=NULL; curr_mos=curr_mos->next)
			    {
				if(!strcmp(curr_mos->mosname, curr_device->devicename))
				{
				    fprintf(fp_out,"%s %s %s %s %s %s L=%e W=%e\n",curr_mos->mosname,curr_mos->d,curr_mos->g,curr_mos->s,curr_mos->b,curr_mos->modelname,curr_mos->lvalue,curr_mos->wvalue);
				    break;
				}
			    }
			}
			break;
		    }
		}
	    }
	}
    }

    for(MosList *curr_mos=mygroup->left_transistor_list; curr_mos!=NULL; curr_mos=curr_mos->next)
	fprintf(fp_out,"%s %s %s %s %s %s L=%e W=%e\n",curr_mos->mosname,curr_mos->d,curr_mos->g,curr_mos->s,curr_mos->b,curr_mos->modelname,curr_mos->lvalue,curr_mos->wvalue); 

//Output the pass transistor
    fprintf(fp_out,"* Output the pass transistors\n");
    for(MosList *curr_mos=mygroup->pass_transistor_list; curr_mos!=NULL; curr_mos=curr_mos->next)
    {
	int flag=0;
	MosList *curr, *prev, *temp;
	curr=curr_mos;
	prev=curr_mos->next;
	while(curr!=NULL)
	{
	    if((!strcmp(curr_mos->d, curr->d) && !strcmp(curr_mos->s, curr->s)) || (!strcmp(curr_mos->d, curr->s) && !strcmp(curr_mos->s,curr->d)))
	    {
		flag=1;
		fprintf(fp_out,"* Pass transistor -- including %s, %s\n", curr_mos->mosname, curr->mosname);
		fprintf(fp_out,"* input and output signal are:\n");
		fprintf(fp_out,"%s %s\n",curr_mos->d,curr_mos->s);
	        prev->next = curr->next;
                temp = prev->next;
                prev = temp;
                curr = temp->next;
		break;
	    }
	    else
	    {
		prev=curr;
           	curr=curr->next;
	    }
	}
	if(!flag)
	{
	    fprintf(fp_out,"* Pass transistor -- including %s\n", curr_mos->mosname);
	    fprintf(fp_out,"* input and output signal are:\n");
	    fprintf(fp_out,"%s %s\n", curr_mos->d,curr_mos->s);
	}
    }
//Output the model
    fprintf(fp_out,"\n");
    for(Modellist *cur_model=ModelHead; cur_model!=NULL; cur_model=cur_model->next)
    {
	if(cur_model->type==DIOD_TYPE)
	    fprintf(fp_out,".model %s %s Is=%e Vt=%e\n",cur_model->name,cur_model->npmos,cur_model->is,cur_model->vt);    
	if(cur_model->type=MOSFET_TYPE)
	    fprintf(fp_out,".model %s %s level=1 K=%e Vth=%e lambda=%e\n",cur_model->name,cur_model->npmos,cur_model->k,cur_model->vth,cur_model->lambda);
    }

//Output the action
    fprintf(fp_out,"\n");
    for(Action *cur_action=ActionHead; cur_action!=NULL; cur_action=cur_action->next)
    {
	if(cur_action->type==TRAN)
	    fprintf(fp_out,".tran %e %e\n", cur_action->value1,cur_action->value2);
	if(cur_action->type==PRINT_TYPE)
	    fprintf(fp_out,".pring v(%d)\n", cur_action->v);
	if(cur_action->type==OPTION_TYPE)
	    fprintf(fp_out,".op\n");
	if(cur_action->type==END_TYPE)
	    fprintf(fp_out,".end\n");
	if(cur_action->type==DC_TYPE)
	    fprintf(fp_out,".dc %s %e %e %e\n",cur_action->name,cur_action->start,cur_action->end,cur_action->step);
    }

    return 0;
}
	
	
			
	    
