#ifndef MBRANCH_H
#define MBRANCH_H

#include "pre.h"
#include <malloc.h>
#include <stdio.h>


class MBranch {
     
     friend class MGroup;

     public:
	MosList *moshead;
	NodeList *nodehead;

	int success;
	int ready_to_delete;
	int greatthan4;
	char *headername;
	int branch_type;
	char *pn_node;
	MosList *mos_list;
	MosList *bak_mos_list;  // Revised
	int num_of_mos;
	BranchNodeList *node_list;
	NameList *name_list;
	RelationList *relation_list;
	MBranch *next;


	MBranch(int _branch_type, MosList *moshead_, NodeList *nodehead_);
	~MBranch();

	char *get_vdd(MosList *moshead);
	char *get_gnd(MosList *moshead);
	int node_exist(char *node);
	int query_moslist(MosList *mos);
	MosList *insert_mos(MosList *head, MosList *mos);
	BranchNodeList *insert_node(BranchNodeList *head, char *node);
	BranchNodeList *find_new_node(BranchNodeList *branchnode_list, int p_n_type);
	bool generate_branch(MosList *mos, int p_n_type);
	NameList *insert_name(NameList *head, char *name, char virtual_name);
	void back_up_mos_list();
};

#endif
