#ifndef _PRE
#define _PRE

typedef enum {RES, CAP, IND, VS,PULSE_VS, IS, E, H, G, F, D, M} ElementType;
typedef enum {TRAN,PRINT_TYPE,OPTION_TYPE,END_TYPE,DC_TYPE} ActionType;
typedef enum {DIOD_TYPE,MOSFET_TYPE} ModelType;

typedef struct PINLIST{
	char *NodeName;
	struct PINLIST *next;
	} PinList;

typedef struct INOUTLIST{
	char *pinname;
	struct INOUTLIST *next;
	} InoutList;

typedef struct ELEMENT{
	char *name;
	ElementType type;
	PinList *nodelist;
	float value;
        char *Model;
	float l_value;
	float w_value;
	struct ELEMENT *next;
	} Element;

typedef struct ACTION{
	ActionType type;
	float value1;
	float value2;
	int v;
	float start;
	float end;
	float step;
	char * name;
	struct ACTION *next;
	} Action;
	
typedef struct MODELLIST{
	ModelType type;
	char *name;
	char *npmos;
	float is;
	float vt;
	float k;
	float vth;
	float lambda;
	struct MODELLIST *next;
	} Modellist;	

typedef struct MOSLIST{
	char *mosname;
	char *d;
	char *g;
	char *s;
	int  nptype;
	int is_instead;
	char *b;
	char *modelname;
	float lvalue;
	float wvalue; 
	struct MOSLIST *next;
	} MosList;


#endif

